### Function

# GLib utf16_to_ucs4

#### Declaration [src]

    gunichar*
    g_utf16_to_ucs4 (
      const gunichar2* str,
      glong len,
      glong* items_read,
      glong* items_written,
      GError** error
    )

#### Description [src]

Convert a string from UTF-16 to UCS-4.

The result will be nul-terminated.

#### Parameters

`str`

  Type: An array of `guint16`

  A UTF-16 encoded string.

  The length of the array is specified in the `len` argument.
  The data is owned by the caller of the function.

`len`

  Type: `glong`

  The maximum length (number of #gunichar2) of `str` to use. If `len` is negative, then the string is nul-terminated.

`items_read`

  Type: `glong*`

  Location to store number of `gunichar2` read, or `NULL` to ignore. If `NULL`, then `G_CONVERT_ERROR_PARTIAL_INPUT` will be returned in case `str` contains a trailing partial character. If an error occurs then the index of the invalid input is stored here. The value stored here will never be negative.

  The argument will be set by the function.
  The argument can be `NULL`.

`items_written`

  Type: `glong*`

  Location to store number of characters written, or `NULL` to ignore. The value stored here does not include the trailing nul, and will never be negative.

  The argument will be set by the function.
  The argument can be `NULL`.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the function if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gunichar*`

A pointer to a newly allocated UCS-4 string. This value must be freed with `g_free()`.

The caller of the function takes ownership of the data, and is responsible for freeing it.